<?php

/**
 * Carerix Wordpress Plugin
 *
 * @category settings
 * @author Bogdan Ivanov
 * @copyright Copyright (c) 2013 Carerix.com (http://www.carerix.com)
 * @link http://www.carerix.com
 * @since Sep 5, 2013 10:40:09 AM
 * @version $Rev$
 */

/**
 * Parser class
 * Used to parse linkedin urls and uploaded CV's
 */
class Environment_Parser {
	
	const ENDPOINT = 'https://tools.carerix.com/cxparser/parse.php';
	
	static function parse_linkedin_url($linkedin_url)
	{
		$post = array(
			'parse_url_b64' => base64_encode($linkedin_url),
		);
		
		$get_data = array(
			'parser_name' => 'Linkedin',
			'calling_app' => 'CxWordpress',
			'parser_source' => 'url',
		);
		
		$get_suffix = http_build_query($get_data);
		$endpoint = Environment_Parser::ENDPOINT . '?' . $get_suffix;
		
		$ch = curl_init();
		curl_setopt($ch, CURLOPT_URL, $endpoint);
		curl_setopt($ch, CURLOPT_POST , count($post));
                curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
		curl_setopt($ch, CURLOPT_POSTFIELDS, http_build_query($post));
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, TRUE);
		
		$server_response = curl_exec($ch);
		curl_close($ch);
		
		return $server_response;
	}
	
	static function parse_cv_upload($file_real_path, $filename)
	{
		$get_data = array(
			'calling_app' => 'CxWordpress',
			'parser_source' => 'file',
		);
		
		$get_suffix = http_build_query($get_data);
		$endpoint = Environment_Parser::ENDPOINT . '?' . $get_suffix;		
		
		$post = array(
			'parse_file' => '@'.$file_real_path.';filename='.$filename,
			'tk_off' => true,
		);
		
		$ch = curl_init();
		curl_setopt($ch, CURLOPT_URL, $endpoint);
		curl_setopt($ch, CURLOPT_POSTFIELDS, $post);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, TRUE);
                curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
		
		$server_response = curl_exec($ch);
		curl_close($ch);
		return $server_response;
	}
}